#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys, re, mechanize, base64, urllib2, time, calendar
from www2sms_gui_dialog_captcha import *
from PyQt4 import QtCore, QtGui

def UpdatePbar(self, MainWindow, app, value, label):
	MainWindow.Stat.ui.label.setText(label)
	MainWindow.Stat.ui.progressBar.setProperty("value", value)
	app.processEvents()


class ShowCAPTCHA(QtGui.QDialog, Ui_DialogCaptcha):
	def __init__(self, win_parent = None):
		#Init the base class
		QtGui.QDialog.__init__(self, win_parent)
		self.ui = Ui_DialogCaptcha()
		self.ui.setupUi(self)

def error(self, MainWindow, exception, user_msg):
	# Just for error handling stuff.
	MainWindow.Stat.close()
	return exception, user_msg

# Class which holds the provider methods.
class provider():
	# get the printable name for this provider
	def getName(self):
		raise Exception('provider class is a base class only')
	# eventually we will have to separate the advanced features out, and return these as
	# canSchedule(), canSetSender(), canFlash(), but with the current providers these
	# are all either on or off, so we use a single method to describe them
	def hasAdvancedFeatures(self):
		return False
	# Define the number of characters we can use per SMS.
	# 160 is the default SMS length, some providers might strip it down to add som advert.
	# Second argument should be the maximum Length of a message.
	def chars_per_sms(self):
		return 160, 160
	# Specify a regex to test the entered recipient number against and a not you'll like
	# to show to the user
	# Per default we accept everything that looks like this: +{AnyNumber}
	def num_regexp(self, num):
	    	return False, num, 'This is a reply from base class... something went wrong'
	# send the sms
	def sendSMS(self, app, NUMBER, SMSTEXT, LOGIN, PASSWORD):
		return False, "SMS sending not implemented"

# o2online.de 2.1
class provider_o2online_de(provider):
	def getName(self):
		return 'o2online (Deutschland)'
	def hasAdvancedFeatures(self):
		return True
	def SetupGUI(self, MainWindow):
		CT = time.localtime(time.time())
		# Set the year for scheduling SMS. From now to the next three years
		YEAR = CT[0]
		for YEARS in range(YEAR,YEAR + 3, 1):
			MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartYear.addItem(str(YEARS))
			MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopYear.addItem(str(YEARS))
		# Method which is called to get the proper number of days for the schedule start date
		def on_StartDate_changed(self):
			cal = calendar.Calendar()
			sYEAR = int(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartYear.currentText())
			sMONTH = int(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartMonth.currentText())
			MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartDay.clear()
			for DAY in cal.itermonthdays(sYEAR, sMONTH):
				if DAY != 00:
					DAY = '%02d' %(DAY)
					MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartDay.addItem(str(DAY))

		# Method which is called to get the proper number of days for the schedule stop date
		def on_StopDate_changed(self):
			cal = calendar.Calendar()
			sYEAR = int(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopYear.currentText())
			sMONTH = int(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopMonth.currentText())
			MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopDay.clear()
			for DAY in cal.itermonthdays(sYEAR, sMONTH):
				if DAY != 00:
					DAY = '%02d' %(DAY)
					MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopDay.addItem(str(DAY))
		QtCore.QObject.connect(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartMonth, QtCore.SIGNAL("activated(QString)"), on_StartDate_changed)
		QtCore.QObject.connect(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopMonth, QtCore.SIGNAL("activated(QString)"), on_StopDate_changed)
		QtCore.QObject.connect(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartYear, QtCore.SIGNAL("activated(QString)"), on_StartDate_changed)
		QtCore.QObject.connect(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopYear, QtCore.SIGNAL("activated(QString)"), on_StopDate_changed)
		# TODO: Check wy the sheduling for o2online.de is not working.
		# TODO: Meanwhile this is disabled.
		MainWindow.AdvSet.ui.groupBox_AdvancedSchedule.setDisabled(True)

	def chars_per_sms(self):
		return 160, 1800

	def num_regexp(self, num):
		# Remove everything except numbers and "+"
		num = re.sub(r'[^(0-9)|\+]', '', num)
		# Check if the number matches either +491732332 or 01732332
		if re.match('^(\+[1-9][0-9]+)|(0[0-9]+)', num):
			return True, num, 'Valid Number'
		else:
			return False, num, 'Invalid formated number'

	# check for CAPTCHA
	def check_captcha(self, response):
		# RegExp to find the sucking CAPTCHA image
		re_cap = re.compile('jcaptchaReg')
		while re_cap.search(str(response)):
			#Instaciate the CAPTCHA dialog
			sc = ShowCAPTCHA()

			## Download the CAPTCHA with urllib2
			#current_url = br.geturl()
			#base_url = current_url[:current_url.rfind("/")]
			#dl_captcha = urllib2.urlopen("%s/jcaptchaReg" %(base_url))
			#qimg = QtGui.QImage.fromData(dl_captcha.read())
			#pixmap = QtGui.QPixmap.fromImage(qimg)

			## Download the CAPTCHA with urllib2 and save to jpg
			#current_url = br.geturl()
			#base_url = current_url[:current_url.rfind("/")]
			#dl_captcha = urllib2.urlopen("%s/jcaptchaReg" %(base_url))
			#captcha = open("captcha.jpg", 'wb')
			#captcha.write(dl_captcha.read())
			#captcha.close()
			#pixmap = QtGui.QPixmap('captcha.jpg')

			## Download CAPTCHA with mechanize
			current_url = self.br.geturl()
			base_url = current_url[:current_url.rfind("/")]
			dl_captcha = br.open("%s/jcaptchaReg" %(base_url)).read(4096*10)
			qimg = QtGui.QImage.fromData(dl_captcha)
			pixmap = QtGui.QPixmap.fromImage(qimg)
			self.br.back()

			## Download CAPTCHA with mechanize and save to file
			#current_url = br.geturl()
			#base_url = current_url[:current_url.rfind("/")]
			#dl_captcha = br.open("%s/jcaptchaReg" %(base_url)).read(4096*10)
			#captcha = open("captcha.jpg", 'wb')
			#captcha.write(dl_captcha)
			#captcha.close()
			#pixmap = QtGui.QPixmap('captcha.jpg')

			#Set captcha.jpg to show up in the CAPTCHA dialog
			sc.ui.label_captcha.setPixmap(pixmap)
			def getcaptcha():
				self.captchatext = unicode(sc.ui.lineEdit_captcha.text())
			QtCore.QObject.connect(sc.ui.buttonBox_Captcha, QtCore.SIGNAL("accepted()"), getcaptcha)
			sc.show()
			sc.exec_()
			br.select_form(name='riddle')
			self.br.form["riddleValue"] = self.captchatext
			try:
				self.br.submit()
			except Exception, e:
				return error(self, MainWindow, e, 'Kommunikationsfehler')

			response = self.br.response().read()
			if self.re_cap.search(str(response)):
				reply = QtGui.QMessageBox.question(MainWindow, 'CAPTCHA verifikation fehlgeschlagen!', "Nochmal versuchen?", QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
				if reply == QtGui.QMessageBox.No:
					return error(self, MainWindow, False, 'CAPTCHA verifikation abgebrochen durch User')

	def get_advanced_setting(self, MainWindow):
		    	# Read Scheduling settings if activated
			SCHEDULE = []
			if MainWindow.AdvSet.ui.checkBox_AdvancedScheduleRepeat.isChecked():
				# SCHEDULE Layout: ([RECURRENCY, STOPTrueFalse], [YEARstart, YEARstop], [MONTHstart, MONTHstop], [DAYstart, DAYstop], [HOUREstart, HOUREstop], [MINUTEstart, MINUTEstop])
				SCHEDULE.append([ str(MainWindow.AdvSet.ui.comboBox_AdvancedRecurrence.currentText()), MainWindow.AdvSet.ui.checkBox_AdvancedScheduleStop.isChecked() ])
				SCHEDULE.append([ str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartYear.currentText()), str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopYear.currentText()) ])
				SCHEDULE.append([ str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartMonth.currentText()), str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopMonth.currentText()) ])
				SCHEDULE.append([ str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartDay.currentText()), str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopDay.currentText()) ])
				SCHEDULE.append([ str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartHoure.currentText()), str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopHoure.currentText()) ])
				SCHEDULE.append([ str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStartMinute.currentText()), str(MainWindow.AdvSet.ui.comboBox_AdvancedScheduleStopMinute.currentText()) ])
			else:
				SCHEDULE = False

			# Read Sender
			if MainWindow.AdvSet.ui.radioButton_AdvancedMyMobileNumber.isChecked():
				SENDER = "MyNumber"
			elif MainWindow.AdvSet.ui.radioButton_AdvancedAnonym.isChecked():
				SENDER = "Anonym"
			elif MainWindow.AdvSet.ui.radioButton_AdvancedText.isChecked():
				SENDER = MainWindow.AdvSet.ui.lineEdit_AdvancedText.text()

			# Read Special
			FLASH = MainWindow.AdvSet.ui.checkBox_AdvancedFlashSMS.isChecked()

			return SCHEDULE, SENDER, FLASH

	def sendSMS(self, MainWindow, app, NUMBER, SMSTEXT, LOGIN, PASSWORD):
		LOGINURL = 'https://o2online.de/'
		execute = True
		if execute:
			# Get the values for the advanced settings.
			SCHEDULE, SENDER, FLASH = self.get_advanced_setting(MainWindow)
			MainWindow.Stat.show()
			MainWindow.Stat.ui.progressBar.setMinimum(0)
			MainWindow.Stat.ui.progressBar.setMaximum(11)
			# RegExp to check if SMS was send successfully:
			re_suc = re.compile('erfolgreich', re.IGNORECASE)
			# RegEx to check if en error occured
			re_fail = re.compile('(Fehler beim Login)|(Error logging in)', re.IGNORECASE)
			# RegExp to find the link to the SMS center:
			re_meino2 = re.compile('meino2')

			# Instanziate a Browser
			UpdatePbar(self, MainWindow, app, "1", "Initiating the browser")
			try:
				br = mechanize.Browser()
			except Exception, e:
				return error(self, MainWindow, e, "Failed to initiate the Browser")

			# Browser options
			# gzip transfer encoding is experimental! --> Disable it
			br.set_handle_gzip(False)
			br.set_handle_referer(True)
			br.set_handle_redirect(True)
			br.set_handle_equiv(True)
			br.set_handle_robots(False)
			#br._factory.encoding = "UTF-8"
			#br._factory._forms_factory.encoding = "UTF-8"
			#br._factory._links_factory._encoding = "UTF-8"

			# Follows refresh 0 but not hangs on refresh > 0
			br.set_handle_refresh(mechanize._http.HTTPRefreshProcessor(), max_time=1)

			# Debugging stuff
			#br.set_debug_http(True)
			#br.set_debug_responses(True)
			#br.set_debug_redirects(True)
			#logger = logging.getLogger("mechanize")
			#logger.addHandler(logging.StreamHandler(sys.stdout))
			#logger.setLevel(logging.DEBUG)

			# User-Agent
			# Mozilla
			#br.addheaders = [('User-agent', 'Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.1.6) Gecko/20100105 Gentoo Firefox/3.5.6')]
			# Opera
			br.addheaders = [('User-agent', 'Opera/9.80 (X11; Linux x86_64; U; en) Presto/2.5.24 Version/10.54 Gentoo')]

			# Open the O2 website
			UpdatePbar(self, MainWindow, app, "2", "Open the O2 website")
			br.open(LOGINURL)
			response = br.response().read()

			# Select the Login form
			UpdatePbar(self, MainWindow, app, "3", "Log in to MyO2")
			try:
				br.select_form(name='loginForm')
			except Exception, e:
				return error(self, MainWindow, e, "Faild to select the login Form")
			br.form['loginName'] = LOGIN
			br.form['password'] = PASSWORD

			# The dropdown list entry for the URL below has the name "Mein o2"
			# So how can I set the selected item via the name instead of the value like:
			# br.form["url"] = ["Mein o2"]
			#for item in br.form.find_control("url", type="select").items:
			#    print item
			br.form["url"] = ["http://www.o2online.de/nw/meino2/meino2.html?et_cid=22&et_lid=61"]

			try:
				br.submit()
				response = br.response().read()
			except Exception, e:
				return error(self, MainWindow, e, 'Failed to load "Mein O2"')
			if re_fail.search(str(response)):
				return error(self, MainWindow, False, 'Probably wrong login parameters, check your account setup')

			#Check for CAPTCHA request
			UpdatePbar(self, MainWindow, app, "4", "CAPTCHA-Check")
			self.check_captcha(response)

			#Find the Link to the SMS-Center
			#smscenter = br.find_link(text_regex="SMS versenden \(online\)")
			UpdatePbar(self, MainWindow, app, "5", "Open the SMS-Center")
			try:
				br.follow_link(text_regex="SMS versenden \(online\)")
				response = br.response().read()
			except Exception, e:
				return error(self, MainWindow, e, 'Failed to open the link for the SMS-Center')

			#Follow the JavaScript redirect manually
			UpdatePbar(self, MainWindow, app, "6", "Following the redirect")
			redirect = re.findall(r'loc = \'http://.+\'', response)
			if not redirect:
				return error(self, MainWindow, e, 'Failed to find the redirect to the SMS-Center')

			redirect = redirect[0].split()[2].strip('\'')
			try:
				br.open(redirect)
				response = br.response().read()
			except Exception, e:
				return error(self, MainWindow, e, 'Failed to follow the redirect to the SMS-Center')

			# Select the Login form (second time...)
			UpdatePbar(self, MainWindow, app, "7", "Log in to the SMS-Center")
			try:
				br.select_form(name='login')
			except Exception, e:
				return error(self, MainWindow, e, 'Failed to select the second login form')
			br.form['loginName'] = LOGIN
			br.form['password'] = PASSWORD
			try:
				br.submit()
				response = br.response().read()
			except Exception, e:
				return error(self, MainWindow, e, 'Faild for the second login')
			if re_fail.search(str(response)):
				return error(self, MainWindow, False, 'Probably wrong login parameters, check your account setup')

			#Check for CAPTCHA request
			UpdatePbar(self, MainWindow, app, "8", "CAPTCHA-Check")
			self.check_captcha(response)

			# Open the SMS-Center
			UpdatePbar(self, MainWindow, app, "9", "Open the SMS-Center")
			try:
				br.open('https://email.o2online.de/smscenter_new.osp?Autocompletion=1&MsgContentID=-1')
				response = br.response().read()
			except Exception, e:
				return error(self, MainWindow, e, 'Failed to open the SMS-Center')
			# Select the SMS-Form
			try:
				br.select_form(name='frmSMS')
			except Exception, e:
				return error(self, MainWindow, e, 'Failed to select the SMS form')

			# Fill the forms
			UpdatePbar(self, MainWindow, app, "10", "Fill the forms")
			br.form.set_all_readonly(False)
			# FIll in number an SMS-Text
			br.form['SMSTo'] = NUMBER
			br.form['SMSText'] = SMSTEXT
			# Check for FlashSMS
			if FLASH :
				br.form['FlagFlash'] = '1'
			# Check for Anonymous
			if SENDER == "Anonym" :
				br.form['FlagDefSender'] = '1'
				br.form['FlagAnonymous'] = '1'
			# If neuter Anonymous or a Name is provided we send the SMS with the senders number.
			if SENDER != "MyNumber" and SENDER != "Anonym" :
				br.form['FlagDefSender'] = '1'
				br.form['SMSFrom'] = str(SENDER)
			# Scheduling works half way, the SMS is scheduled, but it is send imediately...
			if SCHEDULE :
				StartDate = '%s,%s,%s,%s,%s,%s' %(str(SCHEDULE[1][0]), str(SCHEDULE[2][0]), str(SCHEDULE[3][0]), str(SCHEDULE[4][0]), str(SCHEDULE[5][0]), '00')
				StopDate = '%s,%s,%s,%s,%s,%s' %(str(SCHEDULE[1][1]), str(SCHEDULE[2][1]), str(SCHEDULE[3][1]), str(SCHEDULE[4][1]), str(SCHEDULE[5][1]), '00')
				# See sourcecode of  the webpage for the mapping:
				Frequency_Dict = {'Daily' : '1', 'Weekly' : '2', 'Monthly': '3', 'Yearly' : '4', 'Once' : '5',  'Hourly' : '6'}
				FQ = str(Frequency_Dict[SCHEDULE[0][0]])
				br.form['RepeatType'] = FQ
				br.form['FolderID'] = '3'
				br.form['RepeatStartDate'] = StartDate
				if SCHEDULE[0][1] :
					br.form['RepeatEndType'] = '1'
					br.form['RepeatEndDate'] = StopDate
			# Finally send the SMS
			UpdatePbar(self, MainWindow, app, "11", "Send SMS")
			try:
				#print NUMBER, SMSTEXT, LOGIN, PASSWORD, SCHEDULE, SENDER, FLASH
				br.submit()
				response = br.response().read()
				if re_suc.search(str(response)):
					return error(self, MainWindow, True, 'Provider responded: Ihre SMS wurde erfolgreich versendet')
				else:
					return error(self, MainWindow, False, 'Provider responded: Ihre SMS wurde nicht versendet')
			except Exception, e:
					return error(self, MainWindow, e, 'Submission faild')

# vodafone.nl 1.0
class provider_vodafone_nl(provider):
	def getName(self):
		return 'Vodefone Nederland'
	def hasAdvancedFeatures(self):
		return False
	def chars_per_sms(self):
		return 125, 125
	def num_regexp(self, num):
	    	# Get rid of everything except 
		num = re.sub(r'[^(0-9)|\+]', '', num)
		# handle a couple of number formats (only mobile numbers allowed)
		if re.search(r'^\+316\d{8}$', num):	# ITU format, +31 is the Netherlands
			num = number[3:]
			return True, num, 'Valid Number'
		elif re.search(r'^06\d{8}$', num):	# local dialing format
			num = number[1:]
			return True, num, 'Valid Number'
		else:
			return False, num, 'Only Dutch mobile phone numbers allowed'

	def sendSMS(self, MainWindow, app, NUMBER, SMSTEXT, LOGIN, PASSWORD):
		# TODO: check whether sending worked
		# TODO: handle "2 per day maximum"
		# TODO: localization support (at least English and Dutch)

                # XXX: GUI manipulation
                MainWindow.Stat.show()
		MainWindow.Stat.ui.progressBar.setMinimum(0)
		MainWindow.Stat.ui.progressBar.setMaximum(8)

		# set up our browser
		UpdatePbar(self, MainWindow, app, "1", "Initiating the browser")
		br = mechanize.Browser()
		cj = cookielib.LWPCookieJar()
		br.set_cookiejar(cj)

		# login
		try:
			UpdatePbar(self, MainWindow, app, "2", "Connecting to login page")
			br.open('https://my.vodafone.nl/prive/my_vodafone')
			UpdatePbar(self, MainWindow, app, "3", "Logging in")
			br.select_form(name='login')
			br.form['username'] = LOGIN
			br.form['password'] = PASSWORD
			br.submit()
		except:
			return False, "Error logging in"


		# verify our login worked and return error if not
	   	UpdatePbar(self, MainWindow, app, "4", "Checking login")
		br.response().read()
		try:
			br.find_link(text='Uitloggen')
		except mechanize.LinkNotFoundError:
			return False, 'Login failed'

		# send the SMS
   	        UpdatePbar(self, MainWindow, app, "5", "Opening SMS page")
		try:
			br.open('https://my.vodafone.nl/Prive/My_Vodafone/gratis_sms_versturen')
		except:
			return False, 'Error opening free SMS web page'
   	        UpdatePbar(self, MainWindow, app, "6", "Checking maximum SMS per day")
		response = br.response().read()
		if re.search(r'Je hebt het maximum aantal gratis SMS\'jes bereikt voor vandaag.', response):
			return False, "Provider responded: Je hebt het maximum aantal gratis SMS'jes bereikt voor vandaag."

   	        UpdatePbar(self, MainWindow, app, "7", "Sending SMS")
		try:
			br.select_form(name='controle')
			br.form['phoneNumber'] = number
			br.form['body'] = SMSTEXT
			br.submit()
		except:
			print response
			return False, 'Error submitting SMS form'

		# check to see if our send worked
   	        UpdatePbar(self, MainWindow, app, "8", "Confirming SMS sent")
		response = br.response().read()
		if re.search(r'Je sms\'je is verstuurd.', response):
			return True, "Provider responded: Je sms'je is verstuurd."
		elif re.search(r'Je hebt het maximum aantal gratis SMS\'jes voor vandaag verstuurd.', response):
			return False, "Provider responded: Je hebt het maximum aantal gratis SMS'jes voor vandaag verstuurd."
		else:
			return False, 'Message not sent'
        	MainWindow.Stat.close()
